> For the complete documentation index, see [llms.txt](https://docs.uptiq.ai/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.uptiq.ai/document-ai/api-reference/generation/generate-asynchronously.md).

# Generate asynchronously

`POST /generate` queues document generation and returns `201`.

Requires the `X-Api-Key` header.

### Request body

Send `application/json` using `GenerateRequest`.

| Property     | Type                 | Description                              |
| ------------ | -------------------- | ---------------------------------------- |
| `data`       | array<`SectionItem`> | Sections to render. Supply at least one. |
| `format`     | string               | Output format. Only `docx` is supported. |
| `metadata`   | object               | Business-context metadata.               |
| `style`      | `StyleConfig`        | Styling configuration.                   |
| `webhookUrl` | string               | HTTPS completion webhook URL.            |

#### Section item

| Property      | Type   | Description                |
| ------------- | ------ | -------------------------- |
| `sectionData` | object | Section-specific data.     |
| `sectionKey`  | string | Unique section identifier. |

#### Style configuration

| Property          | Type    | Description                  |
| ----------------- | ------- | ---------------------------- |
| `fontFamily`      | string  | Font family.                 |
| `fontSize`        | integer | Font size from 8 through 72. |
| `headerFooter`    | boolean | Include headers and footers. |
| `lenderName`      | string  | Lender or company name.      |
| `pageNumbers`     | boolean | Include page numbers.        |
| `primaryColor`    | string  | Primary hex color.           |
| `secondaryColor`  | string  | Secondary hex color.         |
| `tableOfContents` | boolean | Include a table of contents. |

### Responses

| Status | Description                        | Schema             |
| ------ | ---------------------------------- | ------------------ |
| `201`  | Created                            | `GenerateResponse` |
| `400`  | Bad Request                        | `ValidationError`  |
| `401`  | The API key is missing or invalid. |                    |

### Example

```bash
curl -X POST "https://<api-host>/generate" \
  -H "X-Api-Key: $DOCAI_API_KEY" \
  -H "Content-Type: application/json" \
  -d '{
         "data": [
           {
             "sectionKey": "borrower",
             "sectionData": {
               "name": "Northwind Trading Co.",
               "entityType": "Corporation"
             }
           },
           {
             "sectionKey": "terms",
             "sectionData": {
               "principal": 250000,
               "ratePct": 7.25,
               "termMonths": 60
             }
           }
         ],
         "format": "docx",
         "style": {
           "lenderName": "Example Bank",
           "tableOfContents": true
         },
         "webhookUrl": "https://example.com/hooks/docai"
       }'
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.uptiq.ai/document-ai/api-reference/generation/generate-asynchronously.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
